#ifndef _HP_HWCAP_TIMING_H
#define _HP_HWCAP_TIMING_H 1

/* We can use the i686 implementation with slight changes.  */
#include <sysdeps/i386/i686/hp-timing.h>

/* We need the definition of HWCAP_I386_TSC.  */
#include <sysdeps/i386/dl-hwcapinfo.h>

/* We need to perform a runtime check for the timestamp register.  */
#undef  HP_SMALL_TIMING_AVAIL
#define HP_SMALL_TIMING_AVAIL (0)

/* HP_TIMING_HWCAP_AVAIL: this macro performs a run-time check for the
   capability.  */
#define HP_TIMING_HWCAP_AVAIL (_dl_hp_timing_avail())

/* Perform the TSC check.  */
#ifdef NEED_HP_TIMING_HWCAP_AVAIL
static inline
unsigned int
_dl_cpuid_edx (unsigned int op)
{
  unsigned int edx;
  __asm__ __volatile__("push %%ebx ; cpuid ; pop %%ebx"
		       : "=d" (edx) : "a" (op) : "ecx");
  return edx;
}

static int
internal_function
_dl_hp_timing_avail (void)
{
  static int has_tsc = -1;

  if (__builtin_expect (has_tsc == -1, 0))
    has_tsc = (_dl_cpuid_edx(1) & HWCAP_I386_TSC) == HWCAP_I386_TSC;

  return has_tsc;
}
#endif

#endif /* hp-timing.h */
